con
  _clkmode = xtal1 + pll16x       
  _clkfreq = 80_000_000
 
   pwmb = 24        'pwm base pin (for stingray wheel motors)
   rsrv = 8         'right ping servo pin
   lsrv = 9         'left ping servo pin
   rpng = 10        'right ping sensor pin
   lpng = 11        'left ping sensor pin
   trp1 = 8         'trigger point of pings in inches
  rbspd = 80        'robot wheels speed
                 
obj

  pg : "ping"          'ping object
  sv : "servo32v5"     'servo object
  pw : "pwmx8"         'pulse width modulation object
  
VAR

  long dist[1]                                    'holds left and right pings detected distance
    
PUB main (pin,addr) | i, mtr1, mtr2
'initialize
  waitcnt(clkfreq*3 + cnt)                        'waste 5 seconds after hitting the power switch so I could prepare to take video!
  pw.start(pwmb, %00001111, 23_000)               'start pwm object on base pin @ 23khz
  sv.set(lsrv, 1000)                              'set pings to look straight ahead
  sv.set(rsrv, 1500)                              '        "    "
  sv.start                                        'start servo object
  forward                                         'start stingray moving forward
 
'main loop

  repeat
    sonar                                         'get right and left pings detected distance
    if dist[0] < trp1 or dist[1] < trp1           'if either right or left ping distance is less than trp1-
      scan_clear                                  '-then turn stingray to the clearest path
                     
pub scan_clear

  sv.set(lsrv, 1500)                              'set pings to look to the sides
  sv.set(rsrv, 1000)                              '        "    "
  reverse                                         'start stingray moving backwards
  waitcnt(clkfreq/4 + cnt)                        'waste some time before stopping stingray moving      
  stop                                            'stop stingray moving
  sonar
  if dist[0] > dist[1]                            'if distance to right is greater than distance to the left-
    right                                         '-then start moving stingray to it's right
    waitcnt(clkfreq + cnt)                        'waste some time before stopping stingray moving       
    stop                                          'stop stingray moving   
  else                                            'else turn stingray to the left
    left                                          'start stingray moving to it's left
    waitcnt(clkfreq + cnt)                        'waste some time before stopping stingray moving     
    stop                                          'stop stingray moving     
  sv.set(lsrv, 1000)                              'set pings to look straight ahead
  sv.set(rsrv, 1500)                              '       "    "
  waitcnt(clkfreq/2 + cnt)                        'waste some time while ping servos are turning
  forward                                         'start stingray moving forward

pub sonar | i                                
                                             
  repeat i from 0 to 1                            'get right and left ping measured distance in inches
    dist[i] := pg.inches(rpng + i)                '         "       "
        
pub stop

  move_robot(0, 0)                                'stop stingray moving
  
pub reverse

  move_robot(-rbspd, -rbspd)                      'start stingray moving in reverse
                    
pub forward

  move_robot(rbspd, rbspd)                        'start stingray moving forward
                  
pub left

  move_robot(-rbspd, rbspd)                       'start stingray turning to it's left
          
pub right

  move_robot(rbspd, -rbspd)                       'start stingray turning to it's right
                  
Pub move_robot(left_wheel, right_wheel)           'set the speed of stingrays left and right wheels,  -255=reverse to 255=forward, 0 = stop               

  left_wheel := -255 #> left_wheel <# 255                                                                                                                                               
  right_wheel := -255 #> right_wheel <# 255                                                                                                                  
  ifnot right_wheel & $80_00_00_00             
    pw.duty(pwmb + 2, right_wheel & $ff)       
    pw.duty(pwmb + 3, 0)                      
  else                                        
    pw.duty(pwmb + 2, 0)                      
    pw.duty(pwmb + 3, (0 - right_wheel) & $ff)  
  ifnot left_wheel & $80_00_00_00                      
    pw.duty(pwmb + 1, left_wheel & $ff)          
    pw.duty(pwmb, 0)                              
  else                                            
    pw.duty(pwmb + 1, 0)                          
    pw.duty(pwmb, (0 - left_wheel) & $ff)         
                          